package eu.mikroskeem.bot.maerahn;

import eu.mikroskeem.bot.maerahn.commands.AlwaysCommand;
import eu.mikroskeem.bot.maerahn.commands.LennyCommand;
import eu.mikroskeem.bot.maerahn.commands.ShrugCommand;
import lombok.Getter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.telegram.telegrambots.api.objects.Update;
import org.telegram.telegrambots.bots.TelegramLongPollingCommandBot;

public class Bot extends TelegramLongPollingCommandBot {
    public Logger logger;
    @Getter private static Bot instance;
    Bot(){
        instance = this;
        this.logger = LoggerFactory.getLogger("Mäerahn");

        /* Register commands */
        //register(new FacepalmCommand(this));
        register(new ShrugCommand(this));
        register(new LennyCommand(this));
        register(new AlwaysCommand(this));

        registerDefaultAction((sender, message)->{
            logger.info(Utils.logMessage(message));
        });

        logger.info("Bot is ready");
    }
    @Override public void processNonCommandUpdate(Update update) {
        if(update.hasMessage()){
            logger.info(Utils.logMessage(update.getMessage()));
        } else if(update.hasEditedMessage()){
            logger.info(Utils.logMessage(update.getEditedMessage()));
        }
    }
    @Override public String getBotToken() {
        return System.getenv("TG_TOKEN");
    }
    @Override public String getBotUsername() {
        return System.getenv("TG_BOTNAME");
    }
}